/**
 *
 */
package Sim;
import java.util.ArrayList;

/**
 * @author Benjamin Willis
 *
 */
public class NodeMonitor {

	private int totalProtocolBytes = 0;
	private int totalUserBytes = 0;

	private double totalSendTime = 0;
	private int packetsOverheard = 0;
	private int packetsArrived = 0;
	private int packetsTerminated = 0;
	private int packetsSent = 0;
	private int framesSent = 0;
	private int framesReceived = 0;
	private Location startPosition;
	private Location endPosition;
	private ArrayList<Packet> packetsOriginated = new ArrayList<Packet>();


	public NodeMonitor(){
	}

	public Location getEndPosition() {
		return endPosition;
	}

	public void setEndPosition(Location endPosition) {
		this.endPosition = endPosition;
	}

	public int getPacketsArrived() {
		return packetsArrived;
	}

	public void incPacketsArrived() {
		this.packetsArrived+=1;
	}

	public void addPacketsOriginated(Packet p){
		packetsOriginated.add(p);
	}

	public ArrayList<Packet> getPacketsOriginated(){
		return packetsOriginated;
	}

	public int getPacketsOverheard() {
		return packetsOverheard;
	}

	public void incPacketsOverheard() {
		this.packetsOverheard +=1;
	}

	public int getPacketsSent() {
		return packetsSent;
	}

	public void incPacketsSent() {
		this.packetsSent += 1;
	}

	public int getFramesReceived() {
		return framesReceived;
	}

	public void incFramesReceived() {
		this.framesReceived += 1;
	}

	public int getFramesSent() {
		return framesSent;
	}

	public int getPacketsTerminated() {
		return packetsTerminated;
	}

	public void incPacketsTerminated() {
		this.packetsTerminated +=1;
	}

	public Location getStartPosition() {
		return startPosition;
	}

	public void setStartPosition(Location startPosition) {
		this.startPosition = startPosition;
	}

	public int getTotalBytes() {
		return totalProtocolBytes + totalUserBytes;
	}

	public int getTotalProtocolBytes() {
		return totalProtocolBytes;
	}

	public int getTotalUserBytes() {
		return totalUserBytes;
	}

	public void addToTotalBytes(int protoBytes, int userBytes) {
		totalProtocolBytes += protoBytes;
		totalUserBytes += userBytes;
	}

	public double getTotalSendTime() {
		return totalSendTime;
	}

	public void addToTotalSendTime(double sendTime) {
		this.totalSendTime += sendTime;
	}

	public void frameSent( HardwareFrame frame ) {
		++framesSent;
		if ( frame.getProtocolData() != null ) {
			totalProtocolBytes += frame.getProtocolData().getSize();
		}
		if ( frame.getUserData() != null ) {
			totalUserBytes += frame.getUserData().getSize();
		}
	}
}
