/*
 * Destination.java
 *
 * Created on May 5, 2007, 9:44 AM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package Sim.Routing.Champ;
import java.util.LinkedList;

/**
 *
 * @author Travis
 */

public class Destination {
    private Integer destination = null;            //path to
    private int distanceToDestination;  //how far is it
    private LinkedList <NextHop>successors;           //next hop/hops       
    private int numberPaths;       //how many next hops allowed
    
    /** Creates a new instance of Destination 
     @param numPaths
     @param destination
     @param distance*/
    public Destination(int numPaths,int destination,int distance) {
        this.setDestination(destination);  //set the destination for this route
        setNumberPaths(numPaths); //how many paths are allowed
        
        //setSuccessors(new NextHop[getNumberPaths()]);  //create an array of how 
                                                     //many successor we can have
        setDistanceToDestination(distance);
    }
    
    
    
    /*
     *getLeastUsedNextHop() will return the least used next hop
     *@return least used next Hop  or null if there rean't
     * any hops
     */
    public NextHop getLeastUsedNextHop(){
        NextHop nextHop = null;
       Integer used = null;
        
       
        if(successors != null){
           for(int i = 0; i < successors.size(); i++){
               if(used == null || used.intValue() > getSuccessors().get(i).getUsedCount()){
                   used = new Integer(this.getSuccessors().get(i).getUsedCount());
                   nextHop = this.getSuccessors().get(i);
               }
           }
        }
        return nextHop;
                
    }

    public Integer getDestination() {
        return destination;
    }

    public void setDestination(int destination) {
       this.destination = destination;
    }

    public int getDistanceToDestination() {
        return distanceToDestination;
    }

    public void setDistanceToDestination(int distanceToDestination) {
        this.distanceToDestination = distanceToDestination;
    }

    public LinkedList<NextHop> getSuccessors() {
          
        return successors;
    }


    public int getNumberPaths() {
        return numberPaths;
    }

    public void setNumberPaths(int numberPaths) {
        this.numberPaths = numberPaths;
    }

    public void setDestination(Integer destination) {
        this.destination = destination;
    }

    public void setSuccessors(LinkedList<NextHop> successors) {
        this.successors = successors;
    }
    
}
