package Sim.Routing.DSR;

import Sim.ProtocolFrame;

/**
 * FloodingHeader is a generic header for any type of flooded packet.
 *
 * @author Jason Winnebeck
 */
public abstract class FloodingHeader implements ProtocolFrame {
	private final int hopsRemaining;

	public FloodingHeader( int hopsRemaining ) {
		if ( hopsRemaining < 0 )
		  throw new IllegalArgumentException( "Parameter hopsRemaining to FloodingHeader.FloodingHeader must be positive or zero, but " + hopsRemaining + " was given." );

		this.hopsRemaining = hopsRemaining;
	}

	public int getHopsRemaining() {
		return hopsRemaining;
	}

	/**
	 * Returns the "serialized" size of this portion of the packet.
	 */
	public int getSize() {
		return 1; //1 for hopsRemaining
	}
}
