package Sim.Routing.DSR;

import Sim.ProtocolFrame;

/**
 * RouteReply contains a response to a RouteRequest by holding a complete path from originator to
 * desired destination.
 *
 * @author Jason Winnebeck
 */
public class RouteReply implements ProtocolFrame {
	private final Route route;

	public RouteReply( Route pathToTarget ) {
		route = pathToTarget;
	}

	public Route getRouteReply() {
		return route;
	}

	/**
	 * Returns the "serialized" size of this portion of the packet.
	 */
	public int getSize() {
		return route.getSize();
	}

	public String toString() {
		return route.toString();
	}
}
