package Sim.Routing.GPSR.Header;

import Sim.Location;
import Sim.ProtocolFrame;

/**
 * Base header that all GPSR packets should contain.  To lessen broadcasting
 * every packet that is seen needs to contain location information from the originator
 * to update location tables, instead of directly relying on broadcasting.
 * 
 * @author Benjamin Willis
 *
 */
public interface Base extends ProtocolFrame{
	/**
	 * All headers should have a way to get the senders address.
	 * @return integer address of the originator node.
	 */
	public int getFromAddress();
	/**
	 * All headers should also have a way to get the senders 
	 * location.
	 * @return location object of the originator node.
	 */
	public Location getFromLocation();
}
