package Sim;

/**
 * SimulationEvent represents an executable event in the {@link Simulation}.
 *
 * @author Jason Winnebeck
 */
public interface SimulationEvent {
	/**
	 * Performs the event that is occuring within a {@link Simulation}. If an event wishes to
	 * re-execute later, it may schedule itself again using the provided Simulation reference.
	 *
	 * @param sim  non-null Simulation
	 * @param time simulation time, exactly equal to the result of {@link Simulation#getTime()}
	 */
	public void perform( Simulation sim, double time );
}
